//
//  Shaders.metal
//  MeshGeneration
//
//  Created by Caroline on 11/3/20.
//  Copyright © 2020 Caroline. All rights reserved.
//

#include <metal_stdlib>
using namespace metal;
#import <simd/simd.h>

struct VertexIn {
  float3 position;
};

struct VertexOut {
  float4 position [[position]];
};

vertex VertexOut vertex_main(constant VertexIn *vertices [[buffer(0)]],
                          constant float4x4 &matrix [[buffer(11)]],
                          uint id [[vertex_id]]) {
  float4 position = matrix * float4(vertices[id].position, 1);
  VertexOut out;
  out.position = position;
  return out;
}

fragment float4 fragment_main(VertexOut in [[stage_in]],
                              constant bool &isWireframe [[buffer(1)]],
                              constant float3 &color [[buffer(0)]]) {
  return float4(color, 1);
}
